// Copyright (C) 2016 Klaralvdalens Datakonsult AB (KDAB).
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

#ifndef QT3DRENDER_RENDER_UPDATEWORLDBOUNDINGVOLUMEJOB_H
#define QT3DRENDER_RENDER_UPDATEWORLDBOUNDINGVOLUMEJOB_H

//
//  W A R N I N G
//  -------------
//
// This file is not part of the Qt API.  It exists for the convenience
// of other Qt classes.  This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.
//

#include <Qt3DCore/qaspectjob.h>
#include <Qt3DRender/private/qt3drender_global_p.h>
#include <QSharedPointer>

QT_BEGIN_NAMESPACE

namespace Qt3DRender {
namespace Render {

class EntityManager;

class Q_3DRENDERSHARED_PRIVATE_EXPORT UpdateWorldBoundingVolumeJob : public Qt3DCore::QAspectJob
{
public:
    UpdateWorldBoundingVolumeJob();

    inline void setManager(EntityManager *manager) noexcept { m_manager = manager; }
    void run() override;

private:
    EntityManager *m_manager;
};

typedef QSharedPointer<UpdateWorldBoundingVolumeJob> UpdateWorldBoundingVolumeJobPtr;

} // namespace Render
} // namespace Qt3DRender

QT_END_NAMESPACE

#endif // QT3DRENDER_RENDER_UPDATEWORLDBOUNDINGVOLUMEJOB_H
